unit UnitForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, CpuId, ExtCtrls, ShellAPI,SystemInfo, OleServer,
  TrayIcon, Menus, Psock, NMFtp;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Label7: TLabel;
    Label6: TLabel;
    Label5: TLabel;
    Label4: TLabel;
    Label3: TLabel;
    Label2: TLabel;
    Label1: TLabel;
    Panel2: TPanel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    GroupBox1: TGroupBox;
    Label20: TLabel;
    Label21: TLabel;
    Label22: TLabel;
    Label23: TLabel;
    Label24: TLabel;
    Label25: TLabel;
    Label26: TLabel;
    GroupBox2: TGroupBox;
    Label19: TLabel;
    PopupMenu1: TPopupMenu;
    Exit1: TMenuItem;
    procedure FormActivate(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
//  CpuData:TCpuData;
//  SysInfo:TSysInfo;

  Capturing :Bool;
  MouseDownSpot : TPoint;
//  MouseDownSpot.X :Integer;
//  MouseDownSpot.Y :Integer;


function Poc3DNowSupport: Boolean; assembler;
implementation

{$R *.dfm}

/////////////////////////////////////////
const
ID_BIT=$200000; // EFLAGS ID bit

function GetCPUSpeed: Double;
const
  DelayTime = 500;
var
  TimerHi, TimerLo: DWORD;
  PriorityClass, Priority: Integer;
begin
try
  PriorityClass := GetPriorityClass(GetCurrentProcess);
  Priority := GetThreadPriority(GetCurrentThread);

  SetPriorityClass(GetCurrentProcess, REALTIME_PRIORITY_CLASS);
  //SetThreadPriorit(GetCurrentThread,THREAD_PRIORITY_TIME_CRITICAL);

  Sleep(10);
  asm
    dw 310Fh // rdtsc
    mov TimerLo, eax
    mov TimerHi, edx
  end;
  Sleep(DelayTime);
  asm
    dw 310Fh // rdtsc
    sub eax, TimerLo
    sbb edx, TimerHi
    mov TimerLo, eax
    mov TimerHi, edx
  end;

  SetThreadPriority(GetCurrentThread, Priority);
  SetPriorityClass(GetCurrentProcess, PriorityClass);

  Result := Trunc(TimerLo / (1000.0 * DelayTime)+0.9);
  except end;
end;

/////////////////////////////////////////
{$ifndef ver80} //     32- 
function Poc3DNowSupport: Boolean; assembler;
    asm
      push  ebx
      mov  @Result, True
      mov  eax, $80000000
      dw    $A20F           
      cmp  eax, $80000000
      jbe  @NOEXTENDED    // 3DNow  
      mov  eax, $80000001
      dw    $A20F           
      test  edx, $80000000
      jnz   @EXIT          // 3DNow 
      @NOEXTENDED:
      mov  @Result, False
      @EXIT:
      pop ebx
    end;
    {$endif}
//////////////////////////////////////////

procedure TForm1.FormActivate(Sender: TObject);
var
  lpDisplayDevice: TDisplayDevice;
  dwFlags: DWORD;
  cc: DWORD;
  Status : TMemoryStatus;
begin
  Label1.Caption:='GetVendorString    = '+CpuData.GetVendorString;
  Label2.Caption:='GetExtendedCpuName = '+CpuData.GetExtendedCpuName;
  Label3.Caption:='IntelP5N           = '+CpuData.IntelP5N;
  Label4.Caption:='IntelP6N           = '+CpuData.IntelP6N;
  Label5.Caption:='AMDK5N             = '+CpuData.AMDK5N;
  Label6.Caption:='Cyrix686N          = '+CpuData.Cyrix686N;
  Label7.Caption:='GenericCpuN        = '+CpuData.GenericCpuN;

  Label8.Caption  :='GetCPUFrequency         = '+IntToStr(CpuData.GetCPUFrequency);
  Label9.Caption  :='GetMaxCpuId             = '+IntToStr(CpuData.GetMaxCpuId);
  Label10.Caption :='GetNoCpus               = '+IntToStr(CpuData.GetNoCpus);
  Label11.Caption :='GetMaxExtendedFunctions = '+IntToStr(CpuData.GetMaxExtendedFunctions);
  Label12.Caption :='GetExtendedL1DCache     = '+IntToStr(CpuData.GetExtendedL1DCache);
  Label13.Caption :='GetExtendedL1ICache     = '+IntToStr(CpuData.GetExtendedL1ICache);
  Label14.Caption :='GetExtendedL2Cache      = '+IntToStr(CpuData.GetExtendedL2Cache);
  Label15.Caption :='P5CacheL1DI             = '+IntToStr(CpuData.P5CacheL1DI);
  Label16.Caption :='P6CacheL1DI             = '+IntToStr(CpuData.P6CacheL1DI);
  Label17.Caption :='P6CacheL2               = '+IntToStr(CpuData.P6CacheL2);
  Label18.Caption :='CPU Speed = '+Format('%f MHz', [GetCPUSpeed]);
  //Label18.Caption :='CPU Speed = '+Trunc(GetCPUSpeed)+' MHz';

  Label19.Caption:='';
  lpDisplayDevice.cb := sizeof(lpDisplayDevice);
  dwFlags := 0;
  cc:= 0;
  while EnumDisplayDevices(nil, cc, lpDisplayDevice , dwFlags) do  begin
    Inc(cc);
    {       lpDisplayDevice}
    Label19.Caption:=Label19.Caption+'    '+lpDisplayDevice.DeviceString;
  end;
  Status.dwLength := sizeof( TMemoryStatus );
  GlobalMemoryStatus( Status );
  Label20.Caption :='     '  +IntToStr(Status.dwMemoryLoad)+'%';
  Label21.Caption :='    '       +IntToStr(Status.dwTotalPhys div 1024417)+'Mb';
  Label22.Caption :='    '+IntToStr(Status.dwAvailPhys div 1024417)+'Mb';
  Label23.Caption :='     '                +IntToStr(Status.dwTotalPageFile div 1024417)+'Mb';
  Label24.Caption :='     '             +IntToStr(Status.dwAvailPageFile div 1024417)+'Mb';
  Label25.Caption :='    '         +IntToStr(Status.dwTotalVirtual div 1024417)+'Mb';
  Label26.Caption :='    '+IntToStr(Status.dwAvailVirtual div 1024417)+'Mb';

end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
Form1.Close;
end;

end.
